import java.awt.*;


public class ArrowCanvas extends Canvas {
    private int[][] adjM =new int[12][12];
    private int[][] szintek =new int[12][12];
    private Node[] nodes = new Node[12];
    private int numLev;
    private boolean notYet =true;
    private boolean szintezett = false;
    //Graphics g;
private double slope;
private double alpha;
    //    Node nd;
public ArrowCanvas(){
    setSize(800,500);
    //    g= getGraphics();
    //    nd = new Node(5,3);
}

public void paint(Graphics g) {
    if(notYet)
	setBackground(Color.pink);
    else 
	{ setBackground(Color.white);
	if (szintezett)
	drawSzintAbra(adjM,szintek,numLev,nodes,g);
	else
	    drawKorAbra(adjM,nodes,g);
	}
}
public void drawArrow(double x1, double y1, double x2, double y2, int number,Graphics g,boolean b) {
    if(b)
	g.setColor(Color.red);
    else
	g.setColor(Color.black);
        slope = Math.atan((y2-y1)/(x2-x1));
        alpha = slope + (Math.PI/12);
	if(x2>x1){
        g.drawLine((int)Math.round(x2-Math.cos(alpha)*15),(int)Math.round(y2-Math.sin(alpha)*15), (int)Math.round(x2), (int)Math.round(y2));
        alpha = slope - (Math.PI/12);
        g.drawLine((int)Math.round(x2-Math.cos(alpha)*15),(int)Math.round(y2-Math.sin(alpha)*15), (int)Math.round(x2), (int)Math.round(y2));
        g.drawLine((int)x1,(int)y1,(int)x2,(int)y2);
        if (y2 >y1)
        g.drawString(Integer.toString(number),(int)Math.round((x2+x1)/2),(int)Math.round((y2+y1)/2));
        else
        g.drawString(Integer.toString(number),(int)Math.round((x2+x1)/2),(int)Math.round((y2+y1)/2)+12);
	}
	else {
        g.drawLine((int)Math.round(x2+Math.cos(alpha)*15),(int)Math.round(y2+Math.sin(alpha)*15), (int)Math.round(x2), (int)Math.round(y2));
        alpha = slope - (Math.PI/12);
        g.drawLine((int)Math.round(x2+Math.cos(alpha)*15),(int)Math.round(y2+Math.sin(alpha)*15), (int)Math.round(x2), (int)Math.round(y2));
        g.drawLine((int)x1,(int)y1,(int)x2,(int)y2);
        if (y2 <y1)
        g.drawString(Integer.toString(number),(int)Math.round((x2+x1)/2),(int)Math.round((y2+y1)/2));
        else
        g.drawString(Integer.toString(number),(int)Math.round((x2+x1)/2),(int)Math.round((y2+y1)/2)+12);
	}
}
    public void drawNode(Node n,int xn, int yn,Graphics g){
	g.drawRect(xn,yn,40,12);
	g.drawLine(xn+15,yn,xn+15,yn+12);
	g.drawString(n.getName(),xn+2,yn+10);
	g.drawString(n.getTime(),xn+17,yn+10);
    }
    public void drawSzintAbra(int[][] adj,int[][] sz,int nl,Node[] nds,Graphics g){
	 int[] posx= new int[12];
	 int[] posy= new int[12];
	 int verti,nzo;
	for(int i=0;i<12;i++)
	    {posx[i]=2+i*((798-nl*40)/(nl)+40);
	    posy[i]=2+i*43;
	    }
	for(int i=0;i<nl;i++){
	    nzo=nonZero(sz[nl-i-1]);
	    for(int j=0;j<nzo;j++){
		if(nds[sz[nl-i-1][j]-1].updated())
		    g.setColor(Color.red);
		if (i%2==0)
		    verti=500-posy[6*j/nzo];
		else
		    verti=posy[6*j/nzo];
		drawNode(nds[sz[nl-i-1][j]-1],posx[i],verti,g);
		g.setColor(Color.black);
		nds[sz[nl-i-1][j]-1].setX(posx[i]);
		nds[sz[nl-i-1][j]-1].setY(verti);
	    }
	}
	for(int i=0;i<12;i++)
	    for(int j=0;j<12;j++)
		if(adj[i][j]!=0)
		    connect(i,j,g,nds);
    }
    public int nonZero(int[] arr){
	int temp = 0;
	while(temp<12 && arr[temp]!=0)
	    temp++;
	return temp;
    }

    
     public void makeSzintAbra(int[][] adj,int[][] sz,int nl,Node[] nds,boolean b){
	 adjM = adj;
	 szintek = sz;
	 numLev = nl;
	 nodes = nds;
	 notYet=false;
	 szintezett=b;
	 repaint();
    }
    public void connect(int i,int j,Graphics g,Node[] nodes){
	int temp;
	int weight=adjM[i][j];
	boolean redd;
	//g.setColor(Color.black);
	if(nodes[i].getLev()<nodes[j].getLev()){ // lev is opposite order!
	    temp = i;
	    i=j;
	    j=temp;
	}
       	redd=nodes[j].getNumTime()-nodes[i].getNumTime()==weight;
	if(nodes[i].getX()<nodes[j].getX())
	    drawArrow(nodes[i].getX()+40,nodes[i].getY()+6,nodes[j].getX()-1,nodes[j].getY()+6,weight,getGraphics(),redd);
	else
	    drawArrow(nodes[i].getX()-1,nodes[i].getY()+6,nodes[j].getX()+40,nodes[j].getY()+6,weight,getGraphics(),redd); 
    }
    public void drawKorAbra(int[][] adj,Node[] nds,Graphics g){
	for(int i=0;i<12;i++){
	    nds[i].setX(250+(int) Math.round(240*Math.cos(2*i*Math.PI/12)));
	    nds[i].setY(250+(int) Math.round(240*Math.sin(2*i*Math.PI/12)));
	    drawNode(nds[i],nds[i].getX(),nds[i].getY(),g);
	}
	for(int i=0;i<12;i++)
	    for(int j=0;j<12;j++)
		if(adj[i][j]!=0)
		    connect(i,j,g,nds);
    }	
}
